/*
 * KxElementsCtrl.java
 *
 * Created on 24 septembre 2008, 08:33
 */

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.application.client.tools.CocktailIcones;
import org.cocktail.application.common.utilities.CocktailConstantes;

import com.webobjects.eointerface.EODisplayGroup;
/**
 *
 * @author  cpinsard
 */
public class EngagementsView extends javax.swing.JFrame {

   	protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

    /** Creates new form KxElementsCtrl */
    public EngagementsView(EODisplayGroup eod) {
        
    	this.eod = eod;
    	
        initComponents();

        initGui();

    }

    public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTable = new javax.swing.JPanel();
        buttonClose = new javax.swing.JButton();
        tfFiltreLibelle = new javax.swing.JTextField();
        buttonSolder = new javax.swing.JButton();
        lblNbEngagements = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        exercices = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        tfFiltreNumero = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        btnRechercher = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Gestion des engagementse");

        viewTable.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        viewTable.setLayout(new java.awt.BorderLayout());

        buttonClose.setText("Fermer");
        buttonClose.setToolTipText("Fermer la fenêtre");
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        tfFiltreLibelle.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N

        buttonSolder.setText("Solder");
        buttonSolder.setToolTipText("Solde des engagements sélectionnés");

        lblNbEngagements.setForeground(new java.awt.Color(102, 102, 255));
        lblNbEngagements.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText("Exercice :");

        exercices.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        exercices.setToolTipText("Exercices budgétaires");
        exercices.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exercicesActionPerformed(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("Libellé eng ?");

        tfFiltreNumero.setFont(new java.awt.Font("Tahoma", 0, 10));

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText("No Engagement ?");

        btnRechercher.setText("Rechercher");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(buttonSolder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 520, Short.MAX_VALUE)
                        .add(lblNbEngagements, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 215, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonClose, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 94, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 933, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(exercices, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 124, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 101, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tfFiltreLibelle, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 104, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 101, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tfFiltreNumero, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 47, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 248, Short.MAX_VALUE)
                        .add(btnRechercher, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 121, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(tfFiltreNumero, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tfFiltreLibelle, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel1)
                    .add(exercices, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel7)
                    .add(btnRechercher))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 632, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(lblNbEngagements, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 24, Short.MAX_VALUE)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(buttonSolder, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 24, Short.MAX_VALUE)
                        .add(buttonClose)))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-969)/2, (screenSize.height-752)/2, 969, 752);
    }// </editor-fold>//GEN-END:initComponents

private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed
// TODO add your handling code here:
    dispose();
}//GEN-LAST:event_buttonCloseActionPerformed

private void exercicesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exercicesActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_exercicesActionPerformed

//    /**
//    * @param args the command line arguments
//    */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new KxElementsView().setVisible(true);
//            }
//        });
//    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnRechercher;
    private javax.swing.JButton buttonClose;
    protected javax.swing.JButton buttonSolder;
    protected javax.swing.JComboBox exercices;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel7;
    protected javax.swing.JLabel lblNbEngagements;
    protected javax.swing.JTextField tfFiltreLibelle;
    protected javax.swing.JTextField tfFiltreNumero;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables
        
    private void initGui() {
    	                
        buttonClose.setIcon(CocktailIcones.ICON_CLOSE);                
        buttonSolder.setIcon(CocktailIcones.ICON_DELETE);
        btnRechercher.setIcon(CocktailIcones.ICON_LOUPE_16);
        
        Vector myCols = new Vector();
		
		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, "ENG_NUMERO", "No", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "ENG_LIBELLE", "Libellé", 125);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "ENG_MONTANT", "Montant", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "ENG_RESTE", "Reste", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "EXE_ORDRE", "Année", 50);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "ENG_ID", "Id", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
                
		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(CocktailConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

    }

	public ZEOTableModel getMyTableModel() {
		return myTableModel;
	}

	public void setMyTableModel(ZEOTableModel myTableModel) {
		this.myTableModel = myTableModel;
	}

	public javax.swing.JButton getButtonClose() {
		return buttonClose;
	}

	public void setButtonClose(javax.swing.JButton buttonClose) {
		this.buttonClose = buttonClose;
	}

	public javax.swing.JButton getButtonSolder() {
		return buttonSolder;
	}

	public void setButtonSolder(javax.swing.JButton buttonSolder) {
		this.buttonSolder = buttonSolder;
	}

	public javax.swing.JComboBox getExercices() {
		return exercices;
	}

	public void setExercices(javax.swing.JComboBox exercices) {
		this.exercices = exercices;
	}

	public javax.swing.JLabel getLblNbEngagements() {
		return lblNbEngagements;
	}

	public void setLblNbEngagements(javax.swing.JLabel lblNbEngagements) {
		this.lblNbEngagements = lblNbEngagements;
	}

	public javax.swing.JTextField getTfFiltreLibelle() {
		return tfFiltreLibelle;
	}

	public void setTfFiltreLibelle(javax.swing.JTextField tfFiltreLibelle) {
		this.tfFiltreLibelle = tfFiltreLibelle;
	}

	public javax.swing.JTextField getTfFiltreNumero() {
		return tfFiltreNumero;
	}

	public void setTfFiltreNumero(javax.swing.JTextField tfFiltreNumero) {
		this.tfFiltreNumero = tfFiltreNumero;
	}

	public javax.swing.JButton getBtnRechercher() {
		return btnRechercher;
	}

	public void setBtnRechercher(javax.swing.JButton btnRechercher) {
		this.btnRechercher = btnRechercher;
	}

}
